// C Source File
// Created 28.11.02; 11:58:18

#define USE_TI89              // Produce .89z File
#define ICI		DlgMessage("ICI","",0,0);

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SET_FILE_IN_USE_BIT		// Pour ne pas planter si on fait appel  HOME tant archiv

#include <tigcclib.h>        		// Include All Header Files
#define fErreur(chn,format...)	{ sprintf(str,chn,##format); DlgMessage("ERREUR",str,1,0);	}
#define Erreur(shane) DlgMessage("ERREUR",shane,1,0)
#define Attention(shane) DlgMessage("ATTENTION",shane,1,0)
#define TABLE_X 100
#define TABLE_Y 50

#define EDITEUR								//Version AVEC diteur
#define DIALOGUES
#ifndef EDITEUR
	#define editeur 0
#endif

#define TrouveSpriteLibre zz=1;	while (sprites[zz][1]!=0 && zz<=SPRITE_LIMIT)	zz++;
#define SPRITE_LIMIT 100
#define MAX_TEMPS_MSG 30
#define MAX_NRJ 60
#define fMESSAGE(ms,format...)	{	sprintf(LeMessage,ms,##format); TempsMsg=MAX_TEMPS_MSG;	}
#define MESSAGE(ms)	{	strcpy(LeMessage,ms); TempsMsg=MAX_TEMPS_MSG;	}
#define GEN 0
#define LUNA 1
#define ABS(x)	((x>0)?(x):(-x))
#define RestoreInt	SetIntVec(AUTO_INT_1,save_int_1)

unsigned char str[100];

char *Ecran, *Ecran2;											//Nos deux crans temporaires
short haut=0;										//Hauteur du perso

//aEcran donne l'adresse d'un des crans en fonction de son numro
#define GetEcran(nEcran)					(void*)(Ecran+LCD_SIZE*nEcran)

#define TAILLE (256*32*3)
#define TAILLE_DONNEES (256*32*2)

#include "Sprites.h"
#include "Lib.h"

#define HW1 0			//ou VTI
#define HW2 1			//Hardware;
#define SetEcran(x)		PortSet(GetEcran(x),237,127)

#define genX			(16*baseX+scrlX+24+2*16)
#define genY			(16*baseY+scrlY+10+2*16)
#define lunaX			(16*baseX+scrlX+LunaX)
#define lunaY			(16*baseY+scrlY+LunaY)

//Pseudos pour les lments sprites
#define sprNo					sprites[zz][0]							//N de sprite
#define sprX					sprites[zz][1]							//Position x du sprite
#define sprY					sprites[zz][2]							//Position y du sprite
#define sprDir				sprites[zz][3]							//Direction du sprite / Divers
#define sprDepX				sprites[zz][4]							//Position x de dpart
#define sprDepY				sprites[zz][5]							//Position y de dpart
#define sprCpt				sprites[zz][6]							//Compteur interne

//Cette fonction sera utilis pendant l'cran HOME
CALLBACK void TempHook(EVENT *ev)
{
	if (ev->Type!=CM_KEYPRESS) return;

	int k = ev->extra.Key.Code;
	if (k==4096+264)													//2nd (4096) + ESC (264) == retour au jeu
		ER_throwVar(1);
}

// Dpart: c'est ici!
int _main(void)
{
//DECLARATIONS
	unsigned char Touches=0;									//Etat des touches (pour CALC_TOUCHES)
	#ifdef EDITEUR
		char editeur=0;
	#endif
	unsigned char *nam;												//Pointeur  la flib
	const char *nom, *sym_nom;								//Nom du fichier
	unsigned char *ptr;
	short a,b,k,temp,motif;										//Variables temporaires
	short x,y;																//Positions de GEN (ou du curseur)
	short DuPer;															//Si on a perdu une vie ou non.
	short baseX, baseY;												//Dfilement (nombre de pices "tiles")
	short scrlX, scrlY;												//Dfilement interne pour chaque pice
	unsigned char (*m1)[TABLE_Y] = NULL;			//Au quai m1 est imprcis. = Matrice du plan #1
	unsigned char (*m2)[TABLE_Y] = NULL;			//Plan #2: Plan d'extension
	unsigned char (*m3)[TABLE_Y] = NULL;			//Plan #3: Plan des sprites
	unsigned short *usPtr;										//Pointeur pour gfx
	FILE *f=NULL, *F=NULL;
	ESI argptr=top_estack;										//Pointeur sur la liste des arguments du prog
	char chaine[5];														//Chane pour l'diteur
	short val,i=0,j,z;												//Variables temporaires
	SCR_RECT rect;														//Le rectangle du curseur
	short xDep, yDep, typeNiv, temps, coulAP;	//Paramtres du niveau
	short c, maxY, zz,tim=0, Niveau, vitesse;
	short nIncrement, sens, vsens;						//Sens de direction de GEN
	short hardware;														//VTI/HW1 ou bien HW2
	INT_HANDLER save_int_1;
	short posX=0, posY=0, ecrX, ecrY;
	//Les timers! Important pour assurer une animation correcte dans le jeu.
	short timerDiamants=0;										//Modulo 7
	short timer2, timer3, timer4;							//Ch'tits timers pour animations
	short roTimer=0;													//Timer pour la rotation
	short timer, trigger3;										//Timers de base servant de dclencheurs
	unsigned char (*m9)[TABLE_Y] = NULL;
	short Pause, Vies, Diamants, En_pause, collision=0;
	unsigned char chn[100], multiNiveau, Attendre_sur_le_timer;
	short collisions[10], colPtr, HautDispo=2, BasDispo=2;
	short attention_bug;
	short nrj,clignote,invincible;						//Etat de GEN
	int (*sprites)[10] = NULL;								//Pour les sprites
	short frameSkip=0;
	char cles[4];
	const char rotX[]={0,1,2,1,0,-1,-2,-1};		//Pour la rotation
	const char rotY[]={-2,-1,0,1,2,1,0,-1};
	char flag=0, baguette_magique=0;
	short TempsMsg=0, PosMsg=0;
	char LeMessage[100];
	char scintillement4;
	char miniEcran[30*14], petitCompteur[30*8];
	char TouchesInterdites[10];
	short contrast=*contraste();							//Merci Franois Leiber!
	short freq=0, cptNrj=0, peut_pas_teleporter;
	char *ecran;
	short favoris[6][3]; 											//Favoris de l'diteur ([DIAMANT]+[4-9])
	short eau=0;
	char perso=GEN;														//Le joueur c'est GEN au dpart.
	short LunaX, LunaY, Gravite, LunaVitesse, vAvance=0, saut=0, descend=0, temp2;
	short defilX, defilY, debu;
	short Precision=0;												//Slectionne le niveau de prcision pour le moteur
	short zone_reactive=0;										//Affiche la zone ractive
	short frame_skip=2, plus_de_temps=0, Facteur=1;
	short saut_obligatoire, scrlNeige=0, PorteCaisse;
	short *masquePtr;
	short typeEv=0, DialogueEnCours=0;
//FIN DECLARATIONS

//INITIALISATION
	save_int_1 = GetIntVec (AUTO_INT_1);

	if (GetArgType(argptr)==STR_TAG)
		nom=GetStrnArg(argptr);									//genplus("fichier") -> nom="fichier";
	else
		return Erreur("Mettez le nom du fichier en argument");

	if (GetArgType(argptr)==31)
		Niveau=GetIntArg(argptr);
	else
		Niveau=1;

#ifdef EDITEUR
	if (nom[0]=='E')	{												//Genre genplus("Efichier") pour l'diter
		editeur=1;
		nom++;																	//On prend la prochaine lettre
	}
#endif

	nam=get_ptr(get_entry((unsigned char *)"gfx"));
	#ifdef EDITEUR
	if (!nam)	{																				//gfx n'existe pas -> on le cre
		nam=mk_ptr((unsigned char *)"gfx",TAILLE+3);		//Allocation pour gfx (=graphiques)
		if (nam==NULL)
			return Erreur("Mmoire insuffisante pour Gfx");
		memset(nam,0,TAILLE);														//Remplit gfx de zros
		nam[0]=255;																			//Flags internes du fichier
		nam[TAILLE]=248;
		nam[TAILLE-1]=0;
		nam[TAILLE-2]='x';
		nam[TAILLE-3]='f';															//} pour l'extension perso 'Gfx'
		nam[TAILLE-4]='G';
		nam[TAILLE-5]=0;
		return Erreur("Veuillez relancer le jeu");
	}
	#else
	if (!nam)
		return Erreur("Gfx n'existe pas");
	#endif
	if (var_len(nam)!=TAILLE+3)											//Eviter les conflits de version et les faux formats!
		return Erreur("Gfx de format inconnu!");

	usPtr=(unsigned short *)nam;
	usPtr++;
	Vies=5;
	memset(favoris,0,sizeof(favoris));
	x=eau=y=baseX=baseY=PorteCaisse=c=vitesse=scintillement4=colPtr=vsens=peut_pas_teleporter=invincible=scrlX=scrlY=attention_bug=timer=timer2=timer3=timer4=DuPer=Pause=Diamants=En_pause=Attendre_sur_le_timer=trigger3=0;
	sens=1;																						//Sens par dfaut == droite
	nrj=cptNrj=MAX_NRJ;
	memset(cles,0,sizeof(cles));
	memset(LeMessage,0,sizeof(LeMessage));
	memset(TouchesInterdites,0,sizeof(TouchesInterdites));
	hardware=_GrayIsRealHW2();
//FIN INITIALISATION

//ALLOCATION
	ecran=malloc(LCD_SIZE);
	if (!ecran)	{
		return Erreur("Mmoire insuffisante pour ecran");
	}
	LCD_save(ecran);

	m1 = calloc (TABLE_X+2, sizeof (*m1));		//Allocation mmoire
	if (!m1)	{																//Pas pu allouer
		free(ecran);
		return Erreur("Mmoire insuffisante pour plan #1");
	}

	m2 = calloc (TABLE_X+2, sizeof (*m2));
	if (!m2)			{
		free(ecran);
		free(m1);
		return Erreur("Mmoire insuffisante pour plan #2");
	}

	m3 = calloc (TABLE_X+2, sizeof (*m3));
	if (!m3)			{
		free(ecran);
		free(m1);
		free(m2);
		return Erreur("Mmoire insuffisante pour plan #3");
	}

	Ecran=malloc(2*LCD_SIZE);									//Deux crans
	Ecran2=Ecran+LCD_SIZE;										//Deuxime cran sur le premier
	if (!Ecran)		{														//Pas pu allouer
		free(ecran);
		free(m1);
		free(m2);
		free(m3);
		return Erreur("Mmoire insuffisante pour Ecran");
	}

	if (!alloc_screen())	{
		free(ecran);
		free(m1);
		free(m2);
		free(m3);
		free(Ecran);
		return Erreur("Mmoire insuffisante pour charset");
	}

	sprites = calloc (SPRITE_LIMIT+3, sizeof (*sprites));
	if (!sprites)	{
		free(ecran);
		free(m1);
		free(m2);
		free(m3);
		free(Ecran);
		free(charset);
		return Erreur("Mmoire insuffisante pour sprites");
	}
//FIN ALLOCATION

//LECTURE FICHIER
lect_fichier:
	//Rinitialisation des variables avant de lire le fichier
	x=y=baseX=baseY=LunaVitesse=clignote=saut_obligatoire=invincible=scrlX=scrlY=attention_bug=timer=timer2=timer3=timer4=DuPer=Pause=Diamants=En_pause=trigger3=0;
	sens=1;																						//Sens par dfaut == droite
	Gravite=2;
	LunaX=24+16*2;
	LunaY=24+16*2;

	nrj=cptNrj=MAX_NRJ;
	memset(sprites,0,(SPRITE_LIMIT+2) * (sizeof (*sprites)));
	memset(m1,0,(TABLE_X+2)*(sizeof (*m1)));
	memset(m2,0,(TABLE_X+2)*(sizeof (*m2)));			//} Remplissage des plans  0
	memset(m3,0,(TABLE_X+2)*(sizeof (*m3)));

	if (!(f=fopen(nom,"r")))	{
		if (!editeur)		{												//On est oblig de jouer avec un niveau rel
			Erreur("Pas pu ouvrir ce fichier");
			goto frie;															//Argh! Tout dsallouer!
		}
		else	{
			//Cration d'un fichier avec les valeurs par dfaut
			if (!(f=fopen(nom,"w")))	{
				Erreur("Pas pu crer ce fichier");
				goto frie;															//Argh! Tout dsallouer!
			}
			fputc(32,f);
			fputc(32,f);
			fputc(1+32,f);
			fputc(300/5+32,f);
			fputc(32,f);
			fputc(22,f);
			fputc(13,f);
			fclose(f);
			Erreur("Veuillez relancer l'diteur");
			goto frie;
		}
	}
	else	{																		//Lecture correcte du fichier
		for (a=1;a<Niveau;a++)	{
			do	{
				c=fgetc(f);
				if (c==EOF)	{												//Fin du fichier
					fErreur("Serie de niveaux terminee au %i!",Niveau);
					goto fin;
				}
			}
			while (c!=16);												//Carr == sparateur de niveaux
		}
		xDep=			fgetc(f)-32;
		yDep=			fgetc(f)-32;
		typeNiv=	fgetc(f)-32;
		temps=		fgetc(f)-32;
		coulAP=		fgetc(f)-32;
		perso=		fgetc(f)-32;
		eau=			fgetc(f)-32;
		if (fgetc(f)!=22)	{
			Erreur("En-tte non-valide (->)");
			fclose(f);
			goto frie;
		}
		if (fgetc(f)!=13)	{
			Erreur("En-tte non-valide (\15)");
			fclose(f);
			goto frie;
		}

		if (ControleEnTete(xDep,yDep,typeNiv,temps,coulAP,perso,eau))
			goto fin;															//Erreur dans l'en-tte!
		eau*=8;

		for (temp=1;temp<=3;temp++)	{
			if (temp==1)
				m9=m1;
			else if (temp==2)
				m9=m2;
			else if (temp==3)
				m9=m3;
			for (b=0;b<TABLE_Y;b++)	{
				for (a=0;a<TABLE_X;a++)	{
					if (feof(f))	goto finLectFich;			//Fin du fichier (EOF = End Of File)
					c=fgetc(f);
					if (c==13)		break;
					if (c==16)		goto finLectFich;			//Niveau termin
					if (c==22)		goto prochaine_section;
					if (c==17)	{
						motif=fgetc(f)-32;
						i=a;
						a+=fgetc(f)-31;
						for (j=i;j<a;j++)		m9[j][b]=motif;
						a--;
					}
					else if (c==18) a+=fgetc(f)-32;
					else					m9[a][b]=c-32;
				}
			}
prochaine_section:
			if (fgetc(f)!=13)	{
				Erreur("Manque \15 aprs ->");
				fclose(f);
				goto frie;
			}
		}
	}
	finLectFich:
	fclose(f);
	temps*=5;
	baseX=xDep-3;
	baseY=yDep-2;
	if (!editeur)
		SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	if (!GrayOn())	{													//Lance le nivelage de gris
		Erreur("Mmoire insuffisante pour le gris");
		goto frie;
	}
	if (!editeur)
		goto jeu;
//FIN LECTURE FICHIER

//EDITEUR
#ifdef EDITEUR
	while(1)	{
		x*=16;																	//Chaque pice du dcor fait 16x16 pixels
		y*=16;
		for (a=0;a<=1;a++)
			memset(GetEcran(a),0,LCD_SIZE);				//Vidage cran;
		Pause=1;																//Moteur  l'arrt (avec animations et tout)
		goto affImage;													//On affiche le contenu de l'cran
editeur:
		for (a=0;a<=1;a++)
			memcpy(GetPlane(a),GetEcran(a),LCD_SIZE);
		rect=(SCR_RECT){{x-16*baseX+24,y-16*baseY+10,x-16*baseX+15+24,y-16*baseY+15+10}};
		x/=16;
		y/=16;																	//Retour aux positions initiales
		printf_xy(0,93,"X=%02i | Y=%02i",x,y);	//Etat du curseur
		while(1)	{
			OSFreeTimer(6);
			OSRegisterTimer(6,10);								//Timer pour 1/2 seconde
			ScrRectFill(&rect,ScrRect,2);					//Rectangle clignotant
			while (!OSTimerExpired(USER_TIMER))	{	//Attente
//			idle();															//Basse consommation de piles non-disponible ici!
				if (kbhit())
					goto plusbas;											//Touche appuye: travail termin!
			}
		}
		plusbas:
		k=AtTouche();														//La touche appuye?

		//Touches spcifiques
		if (k==KEY_ESC) break;									//Quitte. Voir Sauvegarde du fichier
		if (k==KEY_APPS)
			EditGfx((unsigned short *)nam+1);			//Editeur de graphiques

		if (k>=8192+'4' && k<=8192+'9')	{				//[Diamant]+[4  9], 8192 == Diamant
			k-=8192+'4';													//Pour avoir l'emplacement depuis la touche (0  5)
			//Stockage dans les favoris
			favoris[k][0]=m1[x][y];
			favoris[k][1]=m2[x][y];
			favoris[k][2]=m3[x][y];
		}

		if (k>='4' && k<='9')	{
			k-='4';																//Si k vaut '4' il vaudra zro ensuite...
			//Rappel du bloc des favoris
			m1[x][y]=favoris[k][0];
			m2[x][y]=favoris[k][1];
			m3[x][y]=favoris[k][2];
		}
		if (k==257)															//<- == supprimer le bloc
			m1[x][y]=m2[x][y]=m3[x][y]=0;

		//Modifications de plan
		if (k>=49 && k<=51)	{
			memset(chaine,0,sizeof(chaine));
			j=k-48;
			val=0;																//Supprimer lorsque tous les plans seront implments
			if (j==1)
				val=m1[x][y];
			else if (j==2)
				val=m2[x][y];
			else if (j==3)
				val=m3[x][y];
			z=0;
			while (z<3)	{
				LCD_restore(Ecran);
				if (z==0)														//Au dpart: Valeur courante du motif
					printf_xy(0,93,"#%i=%03i",j,val);
				else
					printf_xy(0,93,"#%i=%03s",j,chaine);		//Puis: Entre de l'utilisateur
				k=AtTouche();
				if (k>=48 && k<=57)
				chaine[z++]=k;
				else break;
			}
			if (k==264)
				k=0;
			if (z>0 && k!=0)	{						//257 (<-) efface le motif
				z=atoi(chaine);
				if (j==1)
					m1[x][y]=z;
				else if (j==2)
					m2[x][y]=z;
				else if (j==3)
					m3[x][y]=z;
			}
		}

		//Touches flches
		nIncrement=1;
		if (k>=4096 && k<=8192)		{							//Touches acclres (2nd)
			k-=4096;															//Retour aux touches standardes
			nIncrement=5;													//Mais plus rapide!
		}
		if (k==337)									x-=nIncrement;
		if (k==340)									x+=nIncrement;
		if (k==338)									y-=nIncrement;
		if (k==344)									y+=nIncrement;

		//Ajustement du curseur (s'il est hors des balises de l'cran)
		if (x<0)										x=0;
		if (x>TABLE_X-2)						x=TABLE_X-2;
		if (y<0)										y=0;
		if (y>TABLE_Y-2)						y=TABLE_Y-2;

		//Ajustement du dfilement cran
		while (x-baseX<0)						baseX--;
		while (y-baseY<0)						baseY--;
		while (x-baseX>6)						baseX++;
		while (y-baseY>4)						baseY++;
 	}
//Sauvegarde du fichier
	GrayOff();
	if (DlgMessage("Attention","Voulez-vous sauver vos modifications?",BT_YES,BT_NO)==KEY_ESC)
		goto frie;																	//Pas de sauvegarde dsire

	push_zstr (nom);
	argptr=top_estack;
	sym_nom=GetSymstrArg(argptr);							//symstr pour la gestion du fichier

	EM_moveSymToExtMem (sym_nom, HS_NULL);		//Archive #nom pour gagner de la place

	f=fopen(nom,"r");
	multiNiveau=0;
	while(!feof(f))
		if (fgetc(f)==16)						multiNiveau++;
	fclose(f);

	if (multiNiveau)	{														//D'abord crire tout jusqu'au niveau courant
		F=fopen(nom,"rt");
		if (!(f=fopen("temp","wt")))	{									//Peut pas l'ouvrir
			Erreur("Fichier temp inaccessible!");
			goto frie;
		}
		for (a=1;a<=Niveau;a++)	{
			while (1)		{
				c=fgetc(F);
				if (a!=Niveau)			{								//Pas crire le niveau courant. On crira la version modifie ensuite
					if (fputc(c,f)==EOF)	{
						Erreur("Mmoire\12fputc(c,f)==EOF");
						goto frie;
					}
				}
				if (c==16)			break;
				if (c==EOF)			break;
			}
		}
	}
	else	{																				//Pas de multi-niveau
		if (!(f=fopen("temp","wt")))	{									//Peut pas l'ouvrir
			Erreur("Fichier temp inaccessible!");
			goto frie;
		}
	}

	eau/=8;
	fputc(xDep+32,f);
	fputc(yDep+32,f);
	fputc(typeNiv+32,f);
	fputc(temps/5+32,f);
	fputc(coulAP+32,f);
	fputc(perso+32,f);
	fputc(eau+32,f);
	fputc(22,f);															//Sparateur de section

	maxY=TABLE_Y-1;

	for (c=1;c<=3;c++)	{
		if (c==1)
			m9=m1;
		else if (c==2)
			m9=m2;
		else if (c==3)
			m9=m3;

		maxY=0;
		for (b=0;b<TABLE_Y-1;b++)	{
			for (a=0;a<TABLE_X;a++)	{
				if (m9[a][b])
					maxY=b;
			}
		}
		//Nombre max de lignes trouv
		for (b=0;b<=maxY;b++)	{
			fputc(13,f);
			zz=0;
			for (z=0;z<TABLE_X;z++)	{
				if (m9[z][b])
					zz=z+1;
			}
			//Nombre max de colonnes trouv
			for (a=0;a<zz;a++)	{
				j=m9[a][b];
				i=0;
				while (m9[a+i][b]==j && a+i<zz) i++;
				i--;
				//Utilisation de la compression
				if (i>=2 && j==0)	{
					fputc(18,f);								//C'est une suite de zros
					fputc(32+i,f);							//Nombre de zros contigus
					a+=i+1;
				}
				if (i>=3 && j!=0)	{
					fputc(17,f);								//C'est une suite de motifs identiques
					fputc(j+32,f);							//Quel est ce motif
					fputc(32+i,f);							//Le nombre de fois qu'il se rpte
					a+=i+1;
				}
				if (fputc(m9[a][b]+32,f)==EOF)	{
					Erreur("Mmoire\12fputc(m9[a][b]+32,f)==EOF");
					goto frie;
				}
			}
		}
		if (c<3)
			fputc(22,f);
	}

	if (multiNiveau && !feof(F))	{
		fputc(13,f);
		fputc(16,f);
		while(!feof(F))	{
			if (fputc(fgetc(F),f)==EOF)	{
				Erreur("Mmoire\12fputc(fgetc(F),f)==EOF");
				goto frie;
			}
		}
		fclose(F);
	}
 	fclose(f);

	TRY
		EM_moveSymToExtMem ($(temp), HS_NULL);					//Archive temp
		EM_moveSymFromExtMem (sym_nom, HS_NULL);				//Unarchiv #nom
 		cmd_copyvar($(temp),sym_nom);										//CopyVar temp,#nom
		EM_moveSymToExtMem (sym_nom, HS_NULL);					//Archive #nom
		EM_moveSymFromExtMem ($(temp), HS_NULL);				//Unarchiv temp
		SymDel($(temp));
 	ONERR
 		Erreur("Copie temp -> #nom chou!");
 	ENDTRY

	TRY
		EM_moveSymFromExtMem (SYMSTR("romtxt\\gfx"), HS_NULL);		//Unarchiv romtxt\gfx
		SymDel(SYMSTR("romtxt\\gfx"));
		cmd_copyvar($(gfx),SYMSTR("romtxt\\gfx"));										//Copie de sauvegarde du gfx
		EM_moveSymToExtMem (SYMSTR("romtxt\\gfx"), HS_NULL);
	ONERR
		Erreur("gfx -> romtxt\\gfx chou!");
	ENDTRY

	goto frie;																	//Travail termin; Au-revoir!
#endif
//FIN EDITEUR

jeu:
	if (Attendre_sur_le_timer)	{
		Attendre_sur_le_timer=0;
 		while (!OSTimerExpired(USER_TIMER));
	}
	for (a=0;a<=1;a++)
		memset(GetPlane(a),0 ,LCD_SIZE);
	SetPlane(1);
	//JEU
	//Tim max sur VTI 2.05: 1750
	//Tim max sur TI89 HW2: 4000
	pokeIO(0x600017,0xC0);		//Drglage du timer...
	while(1)	{
		OSFreeTimer(USER_TIMER);
		if (plus_de_temps)
			OSRegisterTimer(USER_TIMER,2);					//Timer pour synchronisation
		else
			OSRegisterTimer(USER_TIMER,1);					//Timer pour synchronisation

		plus_de_temps=0;
		if (nrj<0)
			break;																//Perdu
		if (nrj>MAX_NRJ)
			nrj=MAX_NRJ;

		if (cptNrj<nrj)
			cptNrj++;
		else if (cptNrj>nrj)
			cptNrj--;

		if (!frameSkip)	{
			memset(petitCompteur,0,sizeof(petitCompteur));

			sprintf(chn,"G=%02i %c=%02i %02i%% T=%03i",Vies,127,Diamants,99-tim/40,temps/2);
			FastStr(80,0,chn,petitCompteur,6,18);								//Texte
			PortSet(petitCompteur,239,5);

			for (a=0;a<=4;a++)
				DrawLine(0,a,cptNrj,a,1);													//Ligne de vie

			for (a=0;a<=1;a++)
				memcpy(GetPlane(a)+95*30,petitCompteur,5*30);			//Sur les deux plans
			PortRestore();
		}

		CALC_TOUCHES;
		//Dtection des touches
		if (_keytest(RR_HOME))	{
			EVENT_HANDLER temp;
			temp = EV_hook;
			GrayOff();
			PortRestore();
			SetIntVec (AUTO_INT_1, save_int_1);
		  EV_hook = TempHook;
			LCD_restore(ecran);
			pushkey(263);
		  TRY
		     EV_eventLoop ();
		  ONERR
		  ENDTRY
			LCD_save(ecran);
			SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
			if (!GrayOn())		{																	//Pas pu faire GrayOn
				SetIntVec(AUTO_INT_1,save_int_1);
				Erreur("Mmoire insuffisante pour GrayOn");
				goto frie;
			}
		  EV_hook = temp;
			GrayAdjust(freq);
			while(_keytest(RR_ESC));
			En_pause=1;
			MESSAGE("Retour au jeu, en pause");
			goto jeu;
		}

		if (_keytest(RR_ESC)) goto fin;												//Arrt immdiat avec ESC

		if (_keytest(RR_F1))	{				//Prcision
			if (!TouchesInterdites[6])	{
				TouchesInterdites[6]=1;
				frame_skip++;
				frame_skip=frame_skip%3;
				if (frame_skip==0)	{
					MESSAGE("Frame skip: 0");
				}
				else if (frame_skip==1)	{
					MESSAGE("Frame skip: 1");
				}
				else	{
					MESSAGE("Frame skip: Auto");
				}
			}
		}
		else
			TouchesInterdites[6]=0;

		if (_keytest(RR_F2))	{				//Prcision
			if (!TouchesInterdites[5])	{
				TouchesInterdites[5]=1;
				zone_reactive=1-zone_reactive;
				if (zone_reactive)	{
					MESSAGE("Zone reactive active");
				}
				else	{
					MESSAGE("Zone reactive inactive");
				}
			}
		}
		else
			TouchesInterdites[5]=0;

		if (_keytest(RR_F3))	{				//Prcision
			if (!TouchesInterdites[4])	{
				TouchesInterdites[4]=1;
				Precision=1-Precision;
				if (Precision)	{
					MESSAGE("Precision -");
				}
				else	{
					MESSAGE("Precision +");
				}
			}
		}
		else
			TouchesInterdites[4]=0;

		if (_keytest(RR_APPS))	{
			if (TouchesInterdites[0]==0)	{
				TouchesInterdites[0]=1;
				En_pause=1-En_pause;
				if (En_pause==1)	{
					MESSAGE("Jeu en pause");
				}
				else
					TempsMsg=0;
			}
		}
		else
			TouchesInterdites[0]=0;

		if (En_pause && TempsMsg<=2)
			TempsMsg=MAX_TEMPS_MSG-2;

		a=_keytest(RR_PLUS);
		b=_keytest(RR_MINUS);

		if (a || b)	{
			if (TouchesInterdites[1]==0)	{
				TouchesInterdites[1]=1;
				if (_SHIFT)	{
					if (b && freq<128)
						freq++;
					else if (freq>-27)
						freq--;
					GrayAdjust(freq);
					fMESSAGE("Rglage fin: %i",128-freq);
				}
				else	{
					if (a)	{
						contrast++;
						OSContrastUp();
					}
					else	{
						contrast--;
						OSContrastDn();
					}
					fMESSAGE("Contraste: %i",contrast);
				}
			}
		}
		else
			TouchesInterdites[1]=0;

		Pause=(En_pause);												//Conditions pour que le moteur soit  l'arrt
#ifdef DIALOGUES
		if (typeEv>=1 && typeEv<=40)	{
			if (typeEv==1 && Diamants>=4)		{
				typeEv=0;
				goto pas_bon;
			}
			Pause=1;
			DialogueEnCours++;
pas_bon:
			;
		}
#endif

		if (perso==GEN && !Pause)	{
			//Touches directionnelles
			if (_GAUCHE)														sens=-1;
			if (_DROITE)														sens= 1;
			//HautDispo et BasDispo vont pouvoir tre enlevs ou rduits  un (ne pas oublier en bas-dessous)
			//car le moteur est (enfin) suffisamment stable.
			vsens=0;
			if (_HAUT && HautDispo==2)							vsens=-1;
			if (_BAS && BasDispo==2)								vsens= 1;
			if (_DIAMOND)
				vitesse=4;
			else
				vitesse=2;
			vAvance=3;
		}
		else if (perso==LUNA && !Pause)	{
			if (timer)	{
				if (LunaVitesse<0)
					LunaVitesse++;
				else if (LunaVitesse>0)
					LunaVitesse--;
			}
			if (TouchesInterdites[3]==0)	{
				if (_DROITE && LunaVitesse<5)								LunaVitesse++;
				if (_GAUCHE && LunaVitesse>-5)							LunaVitesse--;
			}
			else
				TouchesInterdites[3]--;

//			if (Gravite>2)														//Pour interdire de sauter pendant qu'on tombe
//				descend=1;
			if (descend && _2ND)											//Eviter des "double-sauts"
				TouchesInterdites[2]=1;									//On interdit 2nd
			if (!_2ND)	{
				if (saut>1 && saut<11)									//Le saut a t interrompu en plein milieu
					descend=1;
				TouchesInterdites[2]=0;									//On ne recommencera pas  sauter
			}

			if (descend==1)
				saut_obligatoire=0;

			if (saut==-1)							//Si saut a une valeur ngative (en gnral suite  un saut obligatoire),
				saut=1;									//on ne doit pas passer  0, sinon on croira que le saut a t interrompu

			if ((_2ND && !descend && !TouchesInterdites[2]) || saut_obligatoire)	{
				if (++saut>11)													//Saut maximal, utiliser des valeurs ngatives pour de
					descend=1;														//plus amples sauts
				vsens=-1;
				//Kevin Kofler m'avait bien expliqu quelque chose pour calculer la "parabole" d'un saut mais j'y
				//pige que dalle alors je fais comme je peux hein...
				if (saut<0)
					vAvance=7;
				else if (saut<=4)
					vAvance=5;
				else if (saut<=7)
					vAvance=4;
				else if (saut<=9)
					vAvance=3;
				else if (saut<=10)
					vAvance=2;
				else
					vAvance=1;
			}
			else	{
				vsens=1;
				vAvance=Gravite;										//On va descendre (vsens==1) de 'Gravite' pixels
				vsens=1;
				if (timer && Gravite<7)
					Gravite++;
			}
			vitesse=ABS(LunaVitesse);
			if (LunaVitesse>0)													sens=1;
			else if (LunaVitesse<0)											sens=-1;

			if (_DIAMOND)		{										//On va lcher la caisse
				if (!TouchesInterdites[7] && PorteCaisse)	{
					TouchesInterdites[7]=1;
//					m1[x+16*sens][y-16]=1;
					if (m1[x/16+sens][y/16-1]>=1 && m1[x/16+sens][y/16-1]<=114)
						goto pas_lancer;
					TrouveSpriteLibre;							//Il faut crer un sprite de la caisse
					if (zz>SPRITE_LIMIT)						//Mmoire sprites sature...
						goto err_sprite;
					sprNo=104;											//Type du sprite
					sprX=x+16*sens;
					sprX-=sprX%16;
					sprY=y-16;
					sprDir=(3*LunaVitesse)/2;
					if (sprDir>8)	sprDir=8;
					sprDepX=PorteCaisse;						//Type de caisse
					sprCpt=0;
					PorteCaisse=0;									//On ne porte plus de caisse!
					LunaVitesse=0;									//Il a fallu beaucoup de force pour lancer a!
				}
			}
			else
				TouchesInterdites[7]=0;
		}

pas_lancer:
		x=genX;			y=genY;
		if (baseX<-3 || baseY<-2 || baseX>TABLE_X-2 || baseY>TABLE_Y-2)			break;							//Hors de la map == Mort!

		if (Pause)		goto affImage;

		if (peut_pas_teleporter)
			peut_pas_teleporter--;

		if (clignote>0)	{
			clignote--;
			invincible=1;													//On ne pourra se faire toucher par les ennemis
			if (clignote==0)
				baguette_magique=0;
		}
		else
			invincible=0;

		//Affichage du PLAN #1: Arrire-plan
		//PS: C'est le gros bordel, radiatif en plus de a, donc restez loign!
affImage:
		if (!frameSkip)	{
			if (coulAP==0)	{
				for (a=0;a<=1;a++)
					memset(GetEcran(a),0,LCD_SIZE);				//Vidage cran;
			}
			else if (coulAP==1)	{
				for (a=0;a<=1;a++)											//Les deux plans
					memset(GetEcran(a),0,LCD_SIZE);
				i=(16*(baseX%4)+scrlX)/2;								//Dfilement horizontal pour le fond
				i-=i%2;																	//Toujours pair (pour le tramage)
				for (a=0;a<=160;a+=32)
					Sprite32_OR (a-i,10,80,Fond1_i,GetEcran(0));
			}
			else if (coulAP<=3)	{
				//Gris clair, plus la neige pour coulAP==2
				memset(GetEcran(1),0,LCD_SIZE);
				memset(GetEcran(0),0b10101010,LCD_SIZE);
			}
		}
		memset(collisions,0,sizeof(collisions));
		if (!Pause && !editeur)	{

			if (vitesse>7)		vitesse=7;
			if (vitesse<-7)		vitesse=-7;
			if (vAvance>7)		vAvance=7;
			if (vAvance<-7)		vAvance=-7;

			Facteur=1;
			if (Precision && perso!=GEN)	{
				Facteur=2;
				sens*=2;
				vsens*=2;
				if (vitesse%2 && timer%2)	{
					vitesse/=2;
					vitesse++;
				}
				else
					vitesse/=2;
				if (vAvance%2 && timer%2)	{
					vAvance/=2;
					vAvance++;
				}
				else
					vAvance/=2;
				scrlX-=scrlX%2;
				scrlY-=scrlY%2;
			}
//			vitesse*=2;
//			vAvance*=2;
			j=vitesse;
			if (j<vAvance)
				j=vAvance;

			for (c=0;c<=j+1;c++)	{									//On fait a j fois (j==vitesse ou vAvance maximal)
				if (c<vitesse)
					scrlX+=sens;
				if (c<vAvance)
					scrlY+=vsens;
				//Ajustage des variables du dfilement
				while(scrlX>=16)	{
					scrlX-=16;
					baseX++;
				}
				while(scrlX<0)	{
					scrlX+=16;
					baseX--;
				}
				while(scrlY>=16)	{
					scrlY-=16;
					baseY++;
				}
				while(scrlY<0)	{
					scrlY+=16;
					baseY--;
				}
				for (temp2=0;temp2<=(perso==LUNA?1:0);temp2++)	{
					colPtr=0;
					for (b=2-temp2;b<=3-temp2;b++)	{
						for (a=3;a<=4-(scrlX==0?1:0);a++)	{
							z=m1[baseX+a][baseY+b];
							zz=m3[baseX+a][baseY+b];
							if (zz>=65 && zz<80)	{				//Bloc "Spcial" dtect (65-80 sur #3)
								masquePtr=MasqueStd;				//Ces blocs sont traits comme des blocs pleins mme si a
																						//n'est pas tout  fait le cas...
								goto collision;							//Pas besoin de dtecter sur #1
							}
							//Le motif n'est pas un type mortel (dur)
							if (z<1 || z>126)		continue;
							//Calculage du motif en action
							if (z>=33 && z<=40)						//PF type II
								z+=z-33+timer2;
							else if (z>=41 && z<=46)			//PF type III
								z+=8+2*(z-41)+timer3;
							else if (z>=47 && z<=50)			//PF type IV
								z+=20+3*(z-47)+timer4;
							else if (z>=51 && z<=80)			//Type indfini + rserve
								z=0;
							else if (z>=81 && z<=126)			//Blocs inclins (toutes sortes)
								z+=2;
							masquePtr=usPtr+256*32+16*z;
collision:
							//Pr-calculage de ces valeurs pour plus bas
							posX=24+16*a-scrlX;
							posY=10+16*b-scrlY;
							//Inversion du masque (0=vide, 1=plein); c'est le contraire
							//du masque dcor correspondant dans le Gfx
							for (temp=0;temp<16;temp++)
								*(masquePtr+temp)^=0xffff;
							//On va tester la collision. masquePtr pointe sur le sprite masque (invers  prsent)
							if (perso==GEN)	{
								i=GenTestCollide16(posX,posY+1,24+3*16,10+2*16,16,masquePtr,GenCollision+16*(sens<0),colPtr);
							}
							else if (perso==LUNA)	{		//double test pour Luna
								if (temp2)
									i=TestCollide16(posX,posY,24+3*16,10+1*16-1,16,masquePtr,LunaCollision+16*(sens<0));
								else
									i=TestCollide16(posX,posY,24+3*16,10+2*16-1,16,masquePtr,LunaCollision+16*(sens<0));
							}
							if (i)	{										//Collision dtecte
								if (zz==45)
									goto perduUneVie;
								else if (zz==46 && !invincible)	{
									nrj-=10;
									clignote=10;
									invincible=1;
								}
								DuPer=1;									//On aura affaire au moteur 2D!
								if (colPtr==0)						//Aucune collision jusqu' maintenant?
									collisions[colPtr++]=i;	//On stocke le rsultat
								else if (colPtr==1 && ((collisions[0]!=8 && i==8) || (collisions[0]==8 && i!=8)))
									collisions[colPtr++]=i;		//Une condition dj existante. La nouvelle ne sera stocke  la suite de l'ancienne que si elle ne dsigne pas la mme collision
							}
							for (temp=0;temp<16;temp++)		//Rinversion du masque (pour le retrouver comme avant)
								*(masquePtr+temp)^=0xffff;
						}
					}
					if (colPtr>0)	{
						//Gestion du moteur 2D. Car si on arrive ici, c'est qu'on a touch un mur, donc que soit
						//on perdra une vie, soit on sera "redirig" de manire  s'intgrer avec le dcor (dur dur!)
						if (DuPer && !editeur)	{										//Attention: on ne perdra pas dans le cas de l'diteur!
							DuPer=0;																	//Le jeu continue
							if (clignote==0 && perso!=LUNA)	{					//Il est naturel pour Luna de toucher un dcor
																												//mais pas pour Gen ;)
								nrj-=10;																//Ae!
								clignote=10;														//invincible
							}
							for (a=0;a<colPtr;a++)	{									//On peut avoir dtect plusieurs collisions
								collision=collisions[a];								//Optimisation  la Brnni (= la con)
								if (collision>8+(perso==LUNA?0:0))	{		//Quelque chose en dessous de GEN
									scrlY-=Facteur;												//Facteur de prcision 1 avec +, 2 avec -
									BasDispo=0;														//Inutile  prsent je crois
									Gravite=2;														//Pour Luna; on a touch le sol
									descend=0;														//Plus en descente donc
									saut=0;																//Et non-plus en saut
								}
								else if (collision<8-(perso==LUNA?0:0))	{			//Quelque chose en dessus de GEN
									HautDispo=0;
									descend=1;														//Tap la tte: on descend
									if (perso==GEN || saut)
										scrlY+=Facteur;
									else	{
										//Il y a quelque chose en haut mais on est dj sur le sol; cela signifie qu'on peut
										//considrer qu'il y a en fait quelque chose en face de nous sinon a va coincer.
										scrlX-=sens;
										scrlY+=Facteur;
										LunaVitesse=0;
									}
								}
								else			{									//GEN fait face  un objet
									scrlX-=sens;
									LunaVitesse=0;						//Losqu'on touche un mur, on s'immobilise (la vitesse repart
																						// zro quand on va dans l'autre sens)
								}
							}
						}		//if (DuPer...
					}			//if (colptr...
				}				//for (temp2...
			}					//for (c...
		}						//if (!Pause...

		//Bah val... vous pouvez recommencer  lire sans danger potentiel
		sens/=Facteur;
		vsens/=Facteur;

		if (HautDispo<2)
			HautDispo++;
		if (BasDispo<2)
			BasDispo++;

		defilX=scrlX-scrlX%2;
		defilY=scrlY-scrlY%2;
		debu=0;
		if (perso==LUNA && !editeur)	{
			defilY-=8;
			if (defilY<0)
				debu=-1;
		}

		for (b=0+debu;b<6+debu;b++)	{
			for (a=0;a<8;a++)	{
				if (baseX+a<0 || baseY+b<0 || baseX+a>TABLE_X-2 || baseY+b>TABLE_Y-2)	{
dessine_carre_noir:
					if (!frameSkip)
						Sprite16_AFFICH(24+16*a-defilX,10+16*b-defilY,16,Noir,Noir,Ecran,Ecran2);
					continue;
				}
				if (zone_reactive && !frameSkip)	{
					if (!(scintillement4%2) && a>=3 && a<=4-(scrlX==0?1:0) && b>=2-(perso==LUNA?1:0) && b<=3)
						goto dessine_carre_noir;
				}

				z=m1[baseX+a][baseY+b];
				if (z)	{
					posX=24+16*a-defilX;					//Pr-calculer ces valeurs pour limiter la casse plus bas
					posY=10+16*b-defilY;
					if (z>=33 && z<=40)						//PF type II
						z+=z-33+timer2;
					else if (z>=41 && z<=45)	{		//PF type III
						temp=timer4;
						if (temp==3)		temp=1;
						z+=8+2*(z-41)+temp;
					}
					else if (z>=46 && z<=50)			//PF type IV
						z+=20+3*(z-46)+timer4;
					else if (z>=51 && z<=80)			//Type indfini + rserve
						z=0;
					else if (z>=81 && z<=126)			//Blocs inclins (toutes sortes)
						z+=2;
					else if (z>=177 && z<=186)		//Dcors type II
						z+=z-177+timer2;
					else if (z>=187 && z<=192)	{	//Dcors type III
						temp=timer4;
						if (temp==3)		temp=1;
						z+=10+2*(z-187)+temp;
					}
					else if (z>=193 && z<=196)		//Dcors type IV
						z+=10+2*(z-187)+timer3;

					if (z && !frameSkip)
						SPRITE_16(posX,posY,16,usPtr+256*32+16*z,usPtr+32*z,usPtr+32*z+16,Ecran,Ecran2);
				}
			}
		}

		//Hauteur du perso  ajouter. Sert pour les collisions avec les ennemis, plus le niveau de l'eau
		haut=perso==LUNA?8:0;
		ecrX=16*baseX+defilX-24;
		ecrY=16*baseY+defilY-10;

		//Ici on gre l'eau
		i=eau-ecrY;														//Calcul du niveau de l'eau
		if (eau==0 || i>92)		goto pado;			//Le niveau de l'eau est soit dsactiv soit trop bas.
		if (i<1)							i=1;						//L'cran est en fait recouvert d'eau.

		memset(GetEcran(0)+30*i,0b10101010,30*(92-i));
		if (i<10+2*16-haut)	{
			if (random(30)==0)	{									//Cration d'une bulle d'air (pour faire raliste)
				TrouveSpriteLibre;									//Pas de vrification pour zz>SPRITE_LIMIT. De toutes
				//faons, on va stocker quelque chose, car l'emplacement SPRITE_LIMIT est valide.
				sprNo=105;
				sprX=x;
				sprY=y;
				sprCpt=3;
			}
			if (Pause)	goto pado;								//Quand-mme les bulles sur pause...

			//Gen va crever vite fait s'il s'aventure dans l'eau
			if (perso==GEN)																nrj--;
			else if (perso==LUNA && timerDiamants==0)			nrj--;
		}

pado:																			//Me suis pas foul pour lui trouver un nom ce label-l!
		//Affichage + grage des sprites
		for (zz=0;zz<SPRITE_LIMIT;zz++)	{
			if (!sprNo)
				continue;
			switch (sprNo)	{
				case 1:												//Missiles
					if (!Pause)	{
						if (sprX<x+8)								sprDir=1;
						else												sprDir=-1;
						sprX+=sprDir;
					}
					z=sprDir==1?0:13;
					if (!frameSkip)
						SPRITE_16(sprX-ecrX,sprY-ecrY,13,missile_m+z,missile_c+z,missile_f+z,Ecran,Ecran2);
					if (Pause)		break;
					if (sprY<y)									sprY++;
					else												sprY--;
					sprCpt++;
					if (sprCpt>50 || (sprX-16+24>=x-15 && sprX-16+24<=x+15 && sprY+12+10>=y-haut && sprY+10<=y+15))	{
						sprNo=0;
						z=zz;
						TrouveSpriteLibre;							//zz contiendra le n d'un sprite libre
						if (zz>SPRITE_LIMIT)
							goto err_sprite;
						sprNo=2;
						sprX=sprites[z][1]+8;
						sprY=sprites[z][2]+8;
						sprCpt=0;
						zz=z;
					}
					break;
				case 2:
					if (!Pause)	{
						if (x+16>sprX-sprCpt && x<sprX+sprCpt+16 && y+16-haut>sprY-sprCpt && y<sprY+sprCpt && !invincible)	{
							nrj-=20;
							clignote=20;
						}
						sprCpt++;
						if (sprCpt>16)							sprNo=0;					//Termin
					}
					if (sprX-ecrX<24-32 || sprX-ecrX>135 || frameSkip || sprCpt==0)
						break;
/*					ScaleSprite32_AND(explosion_m,Ecran,sprX-ecrX-sprCpt,sprY-ecrY-sprCpt,sprCpt*2,sprCpt*2);
					ScaleSprite32_AND(explosion_m,Ecran2,sprX-ecrX-sprCpt,sprY-ecrY-sprCpt,sprCpt*2,sprCpt*2);
					ScaleSprite32_OR(explosion_c,Ecran2,sprX-ecrX-sprCpt,sprY-ecrY-sprCpt,sprCpt*2,sprCpt*2);*/
//					ScaleSprite32_OR(explosion_f,Ecran,sprX-ecrX-sprCpt,sprY-ecrY-sprCpt,sprCpt*2,sprCpt*2);
					ScaleSprite32_OR(explosion_f+32*(timer>1),Ecran2,sprX-ecrX-sprCpt,sprY-ecrY-sprCpt,sprCpt*2,sprCpt*2);
					break;
				case 3:
				case 4:
				case 5:
					if (editeur || Pause)
						goto dessine_3;

					if (++sprCpt>=50 && sprNo==5)	{
						sprCpt=0;
						z=zz;
						TrouveSpriteLibre;							//zz contiendra le n d'un sprite libre
						if (zz>SPRITE_LIMIT)						//Aucun sprite libre! C'est grave a...
							goto fin;
						sprNo=1;
						sprX=sprites[z][1];
						sprY=sprites[z][2];
						sprCpt=0;
						zz=z;
					}

					if (m1[sprX/16][sprY/16]>=1 && m1[sprX/16][sprY/16]<=128)
						sprDir=1;
					else if (m1[sprX/16][(sprY+24)/16]>=1 && m1[sprX/16][(sprY+24)/16]<=128)
						sprDir=-1;
					if (sprY<0)		sprDir=1;
					sprY+=sprDir;

					//Test gnral pour une collision avec un ennemi (ce qu'il ne faut pas faire!)
					//sprX-larg_gen+debut_ecranX>=x-larg_ennemi && sprX-larg_gen+debut_ecranX<=x+larg_gen-1
					//&& sprY+debut_ecranY+haut_ennemi>=y-haut_gen && sprY+debut_ecranY<=y+haut_gen
					if (sprNo==3)	{
						if (sprX-16+24>=x-15 && sprX-16+24<=x+15 && sprY+13+10>=y-haut && sprY+10<=y+15 && !invincible)	{
							nrj-=15;
							clignote=40;
							if (sens>0)
								scrlX-=8;
							else
								scrlX+=8;
							sens=-sens;
							LunaVitesse=-LunaVitesse;
						}
					}
					else	{
						if (sprX-16+24>=x-31 && sprX-16+24<=x+15 && sprY+24+10>=y-haut && sprY+10<=y+15 && !invincible)	{
							nrj-=15;
							clignote=40;
							if (sens>0)
								scrlX-=8;
							else
								scrlX+=8;
							sens=-sens;
							LunaVitesse=-LunaVitesse;
						}
					}

					if (frameSkip)		break;

dessine_3:
					if (x-8<sprX)
						z=26;
					else
						z=0;
					if (sprNo==3)	z/=2;

					if (sprNo==3)
						SPRITE_16(sprX-ecrX,sprY-ecrY,13,avionennemiptit_m+z,avionennemiptit_c+z,avionennemiptit_f+z,Ecran,Ecran2);
					else
						SPRITE_32(sprX-ecrX,sprY-ecrY,26,avionennemi_m+z,avionennemi_c+z,avionennemi_f+z,Ecran,Ecran2);
					break;
				case 6:
						SPRITE_16(sprX-ecrX,sprY-ecrY,16,ennemi1_m,ennemi1_c,ennemi1_f,Ecran,Ecran2);
						if (Pause)	break;
						sprCpt++;
						if (sprCpt%16>=8)
							sprY++;
						else
							sprY--;
						if (sprCpt==1)	{
							if (sprX<x+8)					sprDir= 2;
							else									sprDir=-2;
						}
						sprX+=sprDir;
						if (sprX-16+24>=x-15 && sprX-16+24<=x+15 && sprY+16+10>=y-haut && sprY+10<=y+15 && !invincible)	{
							nrj-=10;
							clignote=20;
							if (sens>0)
								scrlX-=8;
							else
								scrlX+=8;
							sens=-sens;
							LunaVitesse=-LunaVitesse;
						}
						break;
				case 100 ... 103:																				//Porte qui s'ouvre
					i=16*(sprNo-100);
					if (!frameSkip)
						SPRITE_16(sprX-ecrX,sprY-ecrY,16-sprCpt,MasqueStd,portes_c+i,portes_f+i,Ecran,Ecran2);
					if (Pause)	break;
					sprCpt++;
					if (sprCpt>=16)	{
						m3[sprDepX/16][sprDepY/16]=0;
						sprNo=0;
					}
					break;
				case 104:			//Blocs  porter (une belle merde!)
					i=16*(sprNo-104);
					i+=96;
					SPRITE_16(sprX-ecrX,sprY-ecrY,16,Special_m+i,Special_c+i,Special_f+i,Ecran,Ecran2);
					sprX+=sprDir;
					sprCpt++;
					if (sprCpt>10)
						sprY+=3;
					else
						sprY+=sprCpt/3;

					//Dtection horizontale
					i=(sprDir>0?1:0);
					z=m1[sprX/16+i][sprY/16];
					temp=m3[sprX/16+i][sprY/16];
					if (temp || (z>=1 && z<=114))	{
						sprDir=-sprDir;
						sprX+=sprDir;
					}

					//Dtection verticale
					i=(sprDir>0?1:0);
					z=m1[sprX/16][sprY/16+1];
					temp=m3[sprX/16][sprY/16+1];
					if (temp || (z>=1 && z<=114))	{
						while(BOUNDS_COLLIDE16(sprX+4*sens-16*(sens>0?1:0),sprY,x,y))	sprX+=16*sens;
						while (m3[sprX/16][sprY/16+1] ||
						(m1[sprX/16][sprY/16+1]>=1 && m1[sprX/16][sprY/16+1]<=114))	sprY-=16;
						if (sprX>=0 && sprY>=0 && sprX<TABLE_X*16 && sprY<TABLE_Y*16)
							m3[sprX/16][sprY/16+1]=70+sprDepX;
						else	{
							MESSAGE("Le bloc tait hors de la map");
						}
						sprNo=0;
					}
					break;
				case 105:																	//Bulle d'air (quand Luna est sous l'eau)
						sprCpt++;
						if (sprCpt%16>=8)
							sprX++;
						else
							sprX--;
						if (--sprY<eau)	sprNo=0;							//Hors de l'eau: elle clate
						SPRITE_8(sprX-ecrX,sprY-ecrY,6,bulles_m,bulles_c,bulles_f,Ecran,Ecran2);
					break;
			}
		}

		//En cas d'diteur, on supprime tous les sprites juste aprs que ceux-ci aient t affichs.
		//Si les sprites sont toujours l, ils seront rintroduits dans la section qui va suivre.
		if (editeur)
			memset(sprites,0,(SPRITE_LIMIT+1) * (sizeof (*sprites)));

		if (!editeur && ((clignote>0 && scintillement4%2==0) || clignote==0 || (baguette_magique && clignote<50)))		{
			if (!(baguette_magique && clignote<50 && scintillement4>0))	{
				z=16*(sens<0);
				if (perso==GEN)
					SPRITE_16(24+3*16,10+2*16,16,GenMasque+z,GenClair+z,GenFonce+z,Ecran,Ecran2);			//Dessine GEN
				else if (perso==LUNA)	{
					z*=4;
					if (ABS(vitesse) && !saut && timer>1)
						z+=32;
					SPRITE_16(24+3*16,10+1*16+8,32,Luna_m+z,Luna_c+z,Luna_f+z,Ecran,Ecran2);						//Dessine LUNA
					if (PorteCaisse)	{
						if (sens<0)
							z=24+3*16-10;
						else
							z=24+3*16+10;
						zz=80+16*PorteCaisse;
						SPRITE_16(z,10+1*16+16,16,Special_m+zz,Special_c+zz,Special_f+zz,Ecran,Ecran2);
					}
				}
			}
		}

		//Affichage du plan #3 (le plan 2 ne contient aucun "dessin"): Mise en place des sprites
		//affichage des plates-formes Passe-Devant.
		for (b=0+debu;b<6+debu;b++)	{
			if (baseY+b<0 || baseY+b>TABLE_Y-2)		continue;
			for (a=0;a<8;a++)	{
				if (baseX+a<0 || baseX+a>TABLE_X-2)	continue;
				z=m3[baseX+a][baseY+b];
				if (z==0) continue;
				if (z)	{
					posX=24+16*a-defilX;
					posY=10+16*b-defilY;						//Pr-calculer ces valeurs pour limiter la casse plus bas
				}
				if (z>=1 && z<=32)	{
cree_sprite:
					TrouveSpriteLibre;							//zz contiendra le n d'un sprite libre
					if (zz>SPRITE_LIMIT)	{
						err_sprite:
						//Aucun sprite libre! C'est grave a...
						RestoreInt;
						Erreur("Aucun sprite libre!");
						goto fin;
					}
					sprNo=z;
					sprX=16*(baseX+a);
					sprY=16*(baseY+b);
					sprDir=1;
					sprDepX=sprX;
					sprDepY=sprY;
					sprCpt=0;
					if (!editeur && z<=32)
						m3[baseX+a][baseY+b]=0;
				}
				else if (z>=33 && z<=36)						//Diamant
					SPRITE_16(posX,posY,16,Diamant_m,Diamant_c+16*timerDiamants,Diamant_f+16*timerDiamants,Ecran,Ecran2);			//Dessine GEN
				else if (z==37)											//Arrive
					SPRITE_16(posX,posY,16,MasqueStd,Arrivee_c,Arrivee_f,Ecran,Ecran2);			//Dessine GEN
				else if (z==38)	{										//Portes (#2 contient le n de porte)
					i=16*m2[baseX+a][baseY+b];
					if (i<64)
						SPRITE_16(posX,posY,16,MasqueStd,portes_c+i,portes_f+i,Ecran,Ecran2);
				}
				else if (z==39)	{										//Cl
					i=16*m2[baseX+a][baseY+b];
					SPRITE_16(posX,posY,16,cles_m,cles_c+i,cles_f+i,Ecran,Ecran2);
				}
				else if (z==40)											//Bulles tlporteuses
					SPRITE_16(posX+rotX[roTimer],posY+rotY[roTimer],16,transporteur_m,transporteur_c,transporteur_f,Ecran,Ecran2);
				else if (z==41)											//Coeur
					SPRITE_16(posX,posY,16,coeur_m+16*timer2,coeur_c+16*timer2,coeur_f+16*timer2,Ecran,Ecran2);
				else if (z==43)
					SPRITE_16(posX,posY,16,MasqueStd,transformateurs_c,transformateurs_f,Ecran,Ecran2);
				else if (z==44)
					SPRITE_16(posX,posY,16,MasqueStd,transformateurs_c+16,transformateurs_f+16,Ecran,Ecran2);
				else if (z==42)											//Baguette magique
					SPRITE_16(posX,posY,16,baguette_m+16*timer2,baguette_c+16*timer2,baguette_f+16*timer2,Ecran,Ecran2);
				else if (z>=65 && z<=80)	{
					temp=16*(z-65);
					SPRITE_16(posX,posY,16,Special_m+temp,Special_c+temp,Special_f+temp,Ecran,Ecran2);
				}
				else if (z>=128 && z<=152)	{
					z+=231-128;												//128==dpart pour les plate-formes de ce type
																						//231==dpart des dessins de ces plate-formes sur le gfx
					SPRITE_16(posX,posY,16,usPtr+256*32+16*z,usPtr+32*z,usPtr+32*z+16,Ecran,Ecran2);
				}		//Fin affichage

				if (!editeur && BOUNDS_COLLIDE16(posX,posY,24+3*16,10+2*16))	{
					if (z>=33 && z<=36)	{
						m3[baseX+a][baseY+b]=0;
						Diamants++;
						if (Diamants%5==0)
							Vies++;
					}
					else if (z==37)	{
						Niveau++;
						OSFreeTimer(USER_TIMER);
						OSRegisterTimer(USER_TIMER,15);
						for (a=0;a<=1;a++)
							memset(GetPlane(a),255,LCD_SIZE);				//cran noir
						Attendre_sur_le_timer=1;									//C'est ce qu'on devra faire avant de continuer
						GrayOff();
						SetIntVec(AUTO_INT_1,save_int_1);
						goto lect_fichier;
					}
					else if (z==38)	{
						scrlX-=vitesse*sens;
						i=m2[baseX+a][baseY+b];
						if (i<4)	{
							if (cles[i])	{
								cles[i]=0;														//On a utilis la cl
								z=100+i;
								m2[baseX+a][baseY+b]=4;								//Encore une porte, oui, mais inconnue.
								goto cree_sprite;											//On cre un sprite du type "porte qui s'ouvre"
							}
						}
					}
					else if (z==39)	{
						i=m2[baseX+a][baseY+b];
						if (i<=3)
							cles[i]=1;															//Pris une cl
						m3[baseX+a][baseY+b]=0;
					}
					else if (z==40 && !peut_pas_teleporter)	{
						i=m2[baseX+a][baseY+b];										//Rfrence du tlporteur
						ptr=&m3[baseX+a][baseY+b];								//Pointeur sur la case  effacer (si la porte ne mne nulle part)
						if (i<32)		j=32;													//La porte zro mnera en fait  la trente-deux
						else				j=-32;												//Et la trente-deux  la zro...
						flag=0;																		//La porte a-t-elle t trouve? Pas encore.
						for (b=0;b<TABLE_Y;b++)	{
							for (a=0;a<TABLE_X;a++)	{
								if (m3[a][b]!=40)	continue;						//Ce n'est pas une bulle!
								if (m2[a][b]==i+j)	{									//On l'a trouve notre porte!
									baseX=a-3;													//On replace le joueur
									baseY=b-2;
									scrlX=scrlY=0;											//Plus de scrolling parasite
									if (clignote<10)
										clignote=10;											//Invincible un court instant
									peut_pas_teleporter=24;
									flag=1;															//La porte a t trouve
								}
							}
						}
						if (flag==0)	{
							//Attention: Aucune porte correspondante n'a t trouve!
							MESSAGE("Cette porte ne mne nulle part!");
							*ptr=0;																	//On efface donc m3[baseX+a][baseY+b]
						}
					}
					else if (z==41)		{													//Pris un coeur
						nrj+=m2[baseX+a][baseY+b];								//#2 contient le nombre de points qu'on gagnera
						m3[baseX+a][baseY+b]=0;										//Effacement du coeur
					}
					else if (z==42)		{
						baguette_magique=1;												//Pour un clignotement spcial
						clignote=10*m2[baseX+a][baseY+b];					//#2 dfinit le temps d'invincibilit
						m3[baseX+a][baseY+b]=0;										//Ca devient bien connu a.
					}
					else if (z==43)
						perso=LUNA;
					else if (z==44)
						perso=GEN;
					else if (z==47 && !editeur)			{						//Type venementiel (a se dit??)
						typeEv=m2[baseX+a][baseY+b];							//Rfrence (n) de l'vnement
						//Note: le fait de mettre typeEv  >0 active automatiquement le mode vnement. Il sera gr
						//plus tard. Maintenant on supprime tous les types rfrenciant le mme vnement.
						for (b=0;b<TABLE_Y;b++)	{
							for (a=0;a<TABLE_X;a++)	{
								if (m3[a][b]!=47)	continue;						//Pas un vnement
								if (m2[a][b]==typeEv)									//Est-ce le bon n?
									m3[a][b]=m2[a][b]=0;								//Alors on le supprime!
							}
						}
					}
					else if (z==67)	{
						LunaVitesse=15;
						sens=1;
					}
					else if (z==68)	{
						LunaVitesse=-15;
						sens=-1;
					}
					else if (z==69)	{
						saut=-15;
						saut_obligatoire=1;
					}
					else if (z==70)	{
						descend=1;
						Gravite=7;
					}
					else if (z==71 && !TouchesInterdites[7])	{
						if (perso==LUNA && _DIAMOND)	{
							TouchesInterdites[7]=1;
							PorteCaisse=1;
							m3[baseX+a][baseY+b]=0;
						}
					}		//Fin objet dtect
				}		//Fin collision
			}		//Fin boucle a
		}		//Fin boucle b

		//Les filtres venant par-dessus les dcors
		scrlNeige+=2;
		if (coulAP==2 && !frameSkip)	{
			scrlNeige=scrlNeige%32;
			for (b=10;b<=90+32;b+=32)
				for (a=24;a<=136+32;a+=32)
					GrisSprite32_ET(a-scrlNeige,b-32+scrlNeige,32,Neige,GetEcran(0),GetEcran(1));
		}

		//Mise  jour des timers:
		timer++;						timer=timer%4;
		trigger3++;
		roTimer++;					roTimer=roTimer%8;
		if (!frameSkip)
			scintillement4++;
		scintillement4=scintillement4%4;
//		scintillement4&=~3;

		timerDiamants++;
		if (timerDiamants>=7)	{
			timerDiamants=0;
			if (!Pause)			temps--;
		}

		if (timer==0)	{
			timer2++;
			timer2=timer2%2;
		}

		if (trigger3%3==0)	{
			timer3++;
			timer3=timer3%3;
		}

		if (trigger3%3==0)	{
			timer4++;
			timer4=timer4%4;
		}

		#ifdef EDITEUR
		if (editeur) goto editeur;							//Affichage termin: Retour  l'diteur.
		#endif

		if (TempsMsg || PosMsg)	{
			if (TempsMsg==MAX_TEMPS_MSG)	{
				memset(miniEcran,0,sizeof(miniEcran));
				z=largeurChn(LeMessage);
				if (z>160)	{
					strcpy(LeMessage,"ERR: Message trop long!");
					z=80;
				}
				FastStr(80-z/2,0,LeMessage,miniEcran,6,18);
				TempsMsg--;
			}

			if (PosMsg<6 && TempsMsg)
					PosMsg++;
			else if (TempsMsg)
				TempsMsg--;

			memcpy(GetPlane(1),miniEcran+30*(6-PosMsg),30*6);
			memcpy(GetPlane(0),miniEcran+30*(6-PosMsg),30*6);

			if (!TempsMsg)
				PosMsg--;
		}

		plus_de_temps=0;
		//Copie des crans
		if (!frameSkip)	{
			if (DialogueEnCours)	{
				CopieEcran(GetPlane(0)-DialogueEnCours*30,Ecran);
				CopieEcran(GetPlane(1)-DialogueEnCours*30,Ecran2);
			}
			else	{
				CopieEcran(GetPlane(0),Ecran);
				CopieEcran(GetPlane(1),Ecran2);
			}
		}
		else	{
			if (frame_skip==2)	{
				if (!OSTimerExpired(USER_TIMER))
					plus_de_temps=1;
				goto pas_d_attente;
			}
		}

#ifdef DIALOGUES
		//Partie vnements (messages)
		if (typeEv>=1 && typeEv<=40 && DialogueEnCours>=10)	{
			switch (typeEv)	{
				case 1:
					Dial("N'oublie pas de prendre tous les diamants...\nCertains sont bien cachs alors ouvre l'oeil!");
					break;
				case 2:
					Dial("Ces objets peuvent me servir de tremplin.");
					break;
				case 3:
					Dial("Je peux prendre ces objets et les lancer sur mes ennemis. Appuie sur la touche Diamant");
					break;
				case 4:
					Dial("Les coeurs permettent d'augmenter ton nergie.\nLeur valeur est variable.");
					break;
				case 5:
					Dial("Ces bulles sont des tlporteurs. Tu ne sais jamais o tu vas attrir!");
					break;
				case 6:
					Dial("N'aie pas peur...\nGen est fait pour aller sous l'eau!");
					break;
				case 7:
					Dial("Les cls te permettent d'ouvrir certaines portes. Attention: elles n'ont pas toutes la mme couleur!");
					break;
				case 8:
					Dial("Ces portes peuvent tre ouvertes avec une cl de couleur correspondante.");
					break;
				case 9:
					Dial("Ces baguettes magiques te rendront invincible durant un petit moment.");
					break;
				default:
					Dial("Type vnementiel 'Message' inconnu");
					break;
			}
			typeEv=0;
			DialogueEnCours=0;
		}
		//Fin de la partie vnements
#endif

		tim=0;
		while(!OSTimerExpired(USER_TIMER)) tim++;

pas_d_attente:
		if (frame_skip==0)
			frameSkip=0;
		else if  (frame_skip==1)	{
			if (timer%2)
				frameSkip=1;
			else
				frameSkip=0;
		}
		else	{
			if (tim==0 && !frameSkip)			frameSkip=1;	//On est en train de ramer -> la prochaine frame sera plus rapide...
			else													frameSkip=0;
		}
	}

perduUneVie:
	Vies--;
	if (Vies<0)	goto fin;
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,15);
	for (a=0;a<=1;a++)
		memset(GetPlane(a),255,LCD_SIZE);				//cran noir
	Attendre_sur_le_timer=1;									//C'est ce qu'on devra faire avant de continuer
	GrayOff();
	SetIntVec(AUTO_INT_1,save_int_1);
	goto lect_fichier;

//FIN JEU
fin:
	GrayOff();
frie:
	LCD_restore(ecran);
	free(ecran);
	free(m1);
	free(m2);
	free(m3);
	free(Ecran);
	free(charset);
	free(sprites);
	SetIntVec(AUTO_INT_1,save_int_1);
	pokeIO(0x600017,0xD0);		//Rerglage du timer...
	GKeyFlush();
	return 0;
}
